﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = GetData();
        }

        private DataTable GetData()
        {
            DataTable dt = new DataTable();

            // Columns
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("Category", typeof(String));
            dt.Columns.Add("Product", typeof(String));
            dt.Columns.Add("Desc", typeof(String));
            dt.Columns.Add("Quantity", typeof(int));

            // Rows
            Random rnd = new Random();
            for(int i = 0; i < 5; i++)
            {
                dt.Rows.Add(new object[] { i, "C1", "Product " + i.ToString(), "aaa", rnd.Next(50, 100) });
            }

            // Primary key
            dt.PrimaryKey = new DataColumn[] { dt.Columns["ID"] };

            return dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns;

            e.Layout.Bands[0].Columns["Category"].MinWidth = 25;
            e.Layout.Bands[0].Columns["Category"].MaxWidth = 25;

            // Add groups to UltraGrid
            UltraGridGroup group1 = e.Layout.Bands[0].Groups.Add("Group1", "Group1");
            UltraGridGroup descGroup = e.Layout.Bands[0].Groups.Add("DescGroup", "Desc");
            UltraGridGroup group3 = e.Layout.Bands[0].Groups.Add("Group3", "Group3");

            // Add columns to groups
            group1.Columns.Add(e.Layout.Bands[0].Columns["ID"]);
            group1.Columns.Add(e.Layout.Bands[0].Columns["Category"]);
            group1.Columns.Add(e.Layout.Bands[0].Columns["Product"]);
            descGroup.Columns.Add(e.Layout.Bands[0].Columns["Desc"]);
            group3.Columns.Add(e.Layout.Bands[0].Columns["Quantity"]);


            descGroup.Width = 225;
            descGroup.Columns["Desc"].MinWidth = 225;
            descGroup.Columns["Desc"].MaxWidth = 225;
            e.Layout.Bands[0].Columns["Desc"].MinWidth = 225;
            e.Layout.Bands[0].Columns["Desc"].MaxWidth = 225;
            e.Layout.Bands[0].Columns["Desc"].Header.Group.Width = 225;
        }
    }
}
